#include "mydef.h"
#include "filtr.h"

#ifdef __CTOS__
SC_MODULE_EXPORT(filtr);
#endif

//SC_MODULE(filtr) 
filtr::filtr(sc_module_name name)
 : sc_module(name),
   clk ("clk"),
   filtr_in ("filtr_in"),
   rst("rst"),
   filtr_out ("filtr_out")
{
    SC_CTHREAD(iir_filter, clk.pos());
    reset_signal_is(rst, true);  // positive edge triggered
}


void filtr::iir_filter()
{

        DATA_TYPE a0=1;
        //DATA_TYPE a1=-1.2108;
        DATA_TYPE a1_numerator=-12108;
        DATA_TYPE a1_denumerator=10000;

        //DATA_TYPE a2=0.59983;
        DATA_TYPE a2_numerator=59983;
        DATA_TYPE a2_denumerator=100000;

        DATA_TYPE b0=1;
        DATA_TYPE b1=2;
        DATA_TYPE b2=1;


        DATA_TYPE inreg=0;
        DATA_TYPE outreg=0;
        DATA_TYPE delay1=0;
        DATA_TYPE delay2=0;
        DATA_TYPE d1mem=0;
        DATA_TYPE temp1=0;
        DATA_TYPE temp2=0;
        
        //-------------------------------------------------------------------
        
        //DATA_TYPE K2 = 0.0073740524;
        DATA_TYPE K2_numerator=73740;
        DATA_TYPE K2_denumerator=10000000;

        DATA_TYPE a02=1;

        //DATA_TYPE a12=-0.94372;
        DATA_TYPE a1_numerator2=-94372;
        DATA_TYPE a1_denumerator2=100000;

        //DATA_TYPE a22=0.24698;
        DATA_TYPE a2_numerator2=24698;
        DATA_TYPE a2_denumerator2=100000;

        DATA_TYPE b02=1;
        DATA_TYPE b12=2;
        DATA_TYPE b22=1;


        DATA_TYPE inreg2=0;
        DATA_TYPE outreg2=0;
        DATA_TYPE delay12=0;
        DATA_TYPE delay22=0;
        DATA_TYPE d1mem2=0;
        DATA_TYPE temp12=0;
        DATA_TYPE temp22=0;
        DATA_TYPE temp32=0;

    wait();

        while(true) {

            delay2=delay1;
            delay1=d1mem;
            inreg=filtr_in.read();

            //SUMIN:
            temp1=delay1*a1_numerator;
            temp2=delay2*a2_numerator;
            d1mem  =  inreg  -  (temp1/a1_denumerator)  -  (temp2/a2_denumerator);

            //SUMOUT:
            outreg  =  (d1mem*b0)  +  (delay1*b1)  +  (delay2*b2);

            //filtr_out.write(outreg);

            //-------------------
            
            delay22=delay12;
            delay12=d1mem2;
            inreg2=outreg;

            //SUMIN:
            temp12=delay12*a1_numerator2;
            temp22=delay22*a2_numerator2;
            d1mem2  =  inreg2  -  (temp12/a1_denumerator2)  -  (temp22/a2_denumerator2);

            //SUMOUT:
            temp32  =  ((d1mem2*b02)  +  (delay12*b12)  +  (delay22*b22))  *  K2_numerator;
            outreg2  =  temp32  /  K2_denumerator;
            filtr_out.write(outreg2);

            wait();

        }
        
};
